regina::NProgressMessage Class Reference
Progress Management

A progress report in which the current state of progress is stored as a string message. More...

`#include <progress/nprogresstypes.h>`

Inheritance diagram for regina::NProgressMessage:

## Public Member Functions

| NProgressMessage ()
| Creates a new progress report with an empty progress message. More...
| NProgressMessage (const std::string &newMessage)
| Creates a new progress report with the given progress message. More...
| NProgressMessage (const char *newMessage)
| Creates a new progress report with the given progress message. More...
std::string | getMessage () const
| Returns a reference to the current progress message. More...
void | setMessage (const std::string &newMessage)
| Sets the current progress message to the given string. More...
void | setMessage (const char *newMessage)
| Sets the current progress message to the given string. More...
bool | hasChanged () const
| Determines if the state of progress has changed since the last query. More...
bool | isFinished () const
| Is the operation whose progress we are reporting completely finished? More...
void | setFinished ()
| Signifies that the operation whose progress we are reporting is completely finished. More...
void | cancel () const
| Called by an external interface to request that the operation whose progress we are reporting be cancelled. More...
bool | isCancelled () const
| Determines whether an external interface has requested that the operation whose progress we are reporting be cancelled. More...
std::string | getDescription () const
| Returns a string description of the current state of progress. More...
virtual bool | isPercent () const
| Determines if the state of progress can be expressed as a percentage. More...
double | getPercent () const
| Returns the current state of progress as a percentage. More...
long | getRealTime () const
| Returns the real time elapsed since this operation began. More...
long | totalCPUTime () const
| Returns the total CPU time consumed by the program from the beginning to the end of this operation. More...
void | writeTextShort (std::ostream &out) const
| Writes this object in short text format to the given output stream. More...
Input and Output
virtual void | writeTextLong (std::ostream &out) const
| Writes this object in long text format to the given output stream. More...
std::string | str () const
| Returns the output from writeTextShort() as a string. More...
std::string | toString () const
| A deprecated alias for str(), which returns the output from writeTextShort() as a string. More...
std::string | detail () const
| Returns the output from writeTextLong() as a string. More...
std::string | toStringLong () const
| A deprecated alias for detail(), which returns the output from writeTextLong() as a string. More...

## Protected Member Functions

virtual std::string | internalGetDescription () const
| Returns a string description of the current state of progress. More...
virtual double | internalGetPercent () const
| Returns the current state of progress as a percentage. More...

## Protected Attributes

bool | changed
| Has the state of progress changed since the last query? More...
bool | cancelled
| Has this operation been cancelled? More...

## Detailed Description

A progress report in which the current state of progress is stored as a string message.

Python:
  Not present; all progress classes communicate with external interfaces through the NProgress interface.

Deprecated:
  This class is deprecated. Please use the more flexible and more streamlined NProgressTracker class instead.

## Constructor & Destructor Documentation

regina::NProgressMessage::NProgressMessage | ( |  | ) |

inline

Creates a new progress report with an empty progress message.

Note that the internal mutex is not locked during construction.

regina::NProgressMessage::NProgressMessage | ( | const std::string & | newMessage | ) |

inline

Creates a new progress report with the given progress message.

Note that the internal mutex is not locked during construction.

Parameters

  newMessage | the current state of progress.

regina::NProgressMessage::NProgressMessage | ( | const char * | newMessage | ) |

inline

Creates a new progress report with the given progress message.

Note that the internal mutex is not locked during construction.

Parameters

  newMessage | the current state of progress.

## Member Function Documentation

void regina::NProgress::cancel | ( |  | ) | const

inline inherited

Called by an external interface to request that the operation whose progress we are reporting be cancelled.

The operation itself should regularly poll isCancelled() to check if an external interface has made this request.

Note that if cancellation is not sensible or appropriate, the operation may freely ignore such cancellation requests and need not poll isCancelled() at all.

This routine is made const since an external interface should be able to cancel an operation even though it should never modify the state of progress.

std::string regina::ShareableObject::detail | ( |  | ) | const

inherited

Returns the output from writeTextLong() as a string.

Returns
  a long text representation of this object.

std::string regina::NProgress::getDescription | ( |  | ) | const

inline inherited

Returns a string description of the current state of progress.

Note that subclasses must override internalGetDescription(), not this routine.

Returns
  the current state of progress.

std::string regina::NProgressMessage::getMessage | ( |  | ) | const

inline

Returns a reference to the current progress message.

Returns
  the current progress message.

double regina::NProgress::getPercent | ( |  | ) | const

inline inherited

Returns the current state of progress as a percentage.

Note that subclasses must override internalGetPercent(), not this routine.

Precondition
  Progress can be expressed as a percentage (see isPercent()).

Returns
  the current state of progress as a percentage.

long regina::NProgress::getRealTime | ( |  | ) | const

inline inherited

Returns the real time elapsed since this operation began.

This routine may be called both during and after the operation.

If the operation has been marked as finished, the total elapsed time from start to finish will be reported. Otherwise the time elasped thus far will be reported.

Returns
  the total elapsed real time, measured in seconds.

See also
  totalCPUTime()

bool regina::NProgress::hasChanged | ( |  | ) | const

inline inherited

Determines if the state of progress has changed since the last query.

A query is defined to be a call to getDescription(), getPercent() or any of the subclass-specific query routines.

This routine allows interfaces to avoid calls to the slower query routines when they can avoid it.

If no query has yet been made, this routine will return `true`.

Returns
  `true` if and only if the state of progress has changed since the last query.

std::string regina::NProgressMessage::internalGetDescription | ( |  | ) | const

inline protected virtual

Returns a string description of the current state of progress.

This function must not touch the mutex, and is not required to alter the changed flag. The getDescription() routine takes care of all of these issues.

Precondition
  The mutex is currently locked.

Returns
  the current state of progress.

Implements regina::NProgress.

double regina::NProgress::internalGetPercent | ( |  | ) | const

inline protected virtual inherited

Returns the current state of progress as a percentage.

The default implementation returns 0.

This function must not touch the mutex, and is not required to alter the changed flag. The getDescription() routine takes care of all of these issues.

Precondition
  Progress can be expressed as a percentage (see isPercent()).
  The mutex is currently locked.

Returns
  the current state of progress as a percentage.

Reimplemented in regina::NProgressFinished, and regina::NProgressNumber.

bool regina::NProgress::isCancelled | ( |  | ) | const

inline inherited

Determines whether an external interface has requested that the operation whose progress we are reporting be cancelled.

If the operation is polling for cancellation requests and it finds that isCancelled() returns `true`, it should generally exit (cleanly) as soon as possible with only partial or no results. However, if cancellation is not sensible or appropriate, the operation may freely ignore such cancellation requests.

Note that even if the underlying operation cancels itself, it should still call setFinished().

Returns
  `true` if and only if an external interface has requested that the operation be cancelled.

bool regina::NProgress::isFinished | ( |  | ) | const

inline inherited

Is the operation whose progress we are reporting completely finished?

Once this routine returns `true`, it will always return `true`; thus there will be no need to call it again.

Returns
  `true` if and only if the operation is finished.

bool regina::NProgress::isPercent | ( |  | ) | const

inline virtual inherited

Determines if the state of progress can be expressed as a percentage.

The default implementation returns `false`.

Returns
  `true` if and only if progress can be expressed as a percentage.

Reimplemented in regina::NProgressFinished, and regina::NProgressNumber.

void regina::NProgress::setFinished | ( |  | ) |

inline inherited

Signifies that the operation whose progress we are reporting is completely finished.

This must be the final member function call to this NProgress object made by the thread performing the corresponding operation. It notifies all other threads that the operation is complete and that this NProgress object can be safely deleted.

This routine should still be called by the operation thread if it cancels itself in response to a request by an external interface (see cancel()).

Python:
  Not present; this should only be called from within the calculation engine routine whose progress is being watched.

void regina::NProgressMessage::setMessage | ( | const std::string & | newMessage | ) |

inline

Sets the current progress message to the given string.

Parameters

  newMessage | the new state of progress.

void regina::NProgressMessage::setMessage | ( | const char * | newMessage | ) |

inline

Sets the current progress message to the given string.

Parameters

  newMessage | the new state of progress.

std::string regina::ShareableObject::str | ( |  | ) | const

inherited

Returns the output from writeTextShort() as a string.

Python:
  This implements the `__str__()` function.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toString | ( |  | ) | const

inline inherited

A deprecated alias for str(), which returns the output from writeTextShort() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type str() instead.

Returns
  a short text representation of this object.

std::string regina::ShareableObject::toStringLong | ( |  | ) | const

inline inherited

A deprecated alias for detail(), which returns the output from writeTextLong() as a string.

Deprecated:
  This routine has (at long last) been deprecated; use the simpler-to-type detail() instead.

Returns
  a long text representation of this object.

long regina::NProgress::totalCPUTime | ( |  | ) | const

inline inherited

Returns the total CPU time consumed by the program from the beginning to the end of this operation.

This routine will only return useful results after the operation has finished.

If the operation has not yet been marked as finished, this routine will return 0.

Warning
  For CPU time calculations to be correct, the same thread that constructs this progress object must also mark it finished.

Returns
  the total CPU time consumed, measured in seconds.

See also
  getRealTime()

void regina::ShareableObject::writeTextLong | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in long text format to the given output stream.

The output should provide the user with all the information they could want. The output should be human-readable, should not contain extremely long lines (so users can read the output in a terminal), and should end with a final newline.

The default implementation of this routine merely calls writeTextShort() and adds a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Reimplemented in regina::NSnapPeaTriangulation, regina::NGroupPresentation, regina::NHomMarkedAbelianGroup, regina::NNormalSurfaceList, regina::NTetrahedron, regina::NSatRegion, regina::NVertex, regina::NEdge, regina::Dim2Triangle, regina::NTriangle, regina::NLayeredSolidTorus, regina::NHomGroupPresentation, regina::NGenericIsomorphism< dim >, regina::NGenericIsomorphism< 2 >, regina::NGenericIsomorphism< 3 >, regina::NTriangulation, regina::NComponent, regina::NTxICore, regina::NTriSolidTorus, regina::NAngleStructureList, regina::Dim2Edge, regina::NBoundaryComponent, regina::NLayeredChain, regina::Dim2Vertex, regina::Dim2Component, regina::NScript, regina::NAugTriSolidTorus, regina::NSpiralSolidTorus, regina::NSurfaceFilterProperties, regina::NLayeredTorusBundle, regina::NManifold, regina::NPlugTriSolidTorus, regina::NMatrixInt, regina::NBlockedSFSTriple, regina::NPluggedTorusBundle, regina::Dim2Triangulation, regina::NSurfaceSubset, regina::NLayeredLensSpace, regina::NLayeredLoop, regina::NFileInfo, regina::NBlockedSFSLoop, regina::NSnappedBall, regina::NBlockedSFSPair, regina::Dim2BoundaryComponent, regina::NTrivialTri, regina::NL31Pillow, regina::NLayeredChainPair, regina::NText, regina::NSurfaceFilterCombination, and regina::NBlockedSFS.

void regina::NProgress::writeTextShort | ( | std::ostream & | out | ) | const

inline virtual inherited

Writes this object in short text format to the given output stream.

The output should be human-readable, should fit on a single line, and should not end with a newline.

Python:
  The parameter out does not exist; standard output will be used.

Parameters

  out | the output stream to which to write.

Implements regina::ShareableObject.

## Member Data Documentation

bool regina::NProgress::cancelled

protected inherited

Has this operation been cancelled?

bool regina::NProgress::changed

mutable protected inherited

Has the state of progress changed since the last query?

The documentation for this class was generated from the following file:

- progress/nprogresstypes.h

Copyright © 1999-2014, The Regina development team
This software is released under the GNU General Public License, with some additional permissions; see the source code for details.
For further information, or to submit a bug or other problem, please contact Ben Burton (bab@debian.org).